/*
 * ak4678.h  --  audio driver for ak4678
 *
 * Copyright (C) 2012 Asahi Kasei Microdevices Corporation
 * Author:
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 */


#ifndef _AK4678_H
#define _AK4678_H


#define AK4678_CLOCK_PLAYBACK	1
#define AK4678_CLOCK_CAPTURE	2
#define AK4678_CLOCK_OTHER		4

/* AK4678 I2C slave address  */
// #define AK4678_I2C_ADDR            0x12

#define AK4678_00_POWER_MANAGEMENT0		0x00
#define AK4678_01_POWER_MANAGEMENT1		0x01
#define AK4678_02_POWER_MANAGEMENT2		0x02
#define AK4678_03_PLL_MODE_SELECT0		0x03
#define AK4678_04_PLL_MODE_SELECT1		0x04
#define AK4678_05_FORMAT_SELECT			0x05
#define AK4678_06_MIC_SIGNAL_SELECT		0x06
#define AK4678_07_MIC_AMP_GAIN			0x07
#define AK4678_08_DIGITL_MIC			0x08
#define AK4678_09_DAC_PATH_SELECT		0x09
#define AK4678_0A_LINE_MANAGEMENT		0x0A
#define AK4678_0B_HP_MANAGEMENT			0x0B
#define AK4678_0C_CP_CONTROL			0x0C
#define AK4678_0D_SPK_MANAGEMENT		0x0D
#define AK4678_0E_LINEOUT_VOLUME		0x0E
#define AK4678_0F_HP_VOLUME				0x0F
#define AK4678_10_SPRC_VOLUME			0x10
#define AK4678_11_LIN_VOLUME			0x11
#define AK4678_12_RIN_VOLUME			0x12
#define AK4678_13_ALCREF_SELECT			0x13
#define AK4678_14_DIGMIX_CONTROL		0x14
#define AK4678_15_ALCTIMER_SELECT		0x15
#define AK4678_16_ALCMODE_CONTROL		0x16
#define AK4678_17_MODE0_CONTROL			0x17
#define AK4678_18_MODE1_CONTROL			0x18
#define AK4678_19_FILTER_SELECT0		0x19
#define AK4678_1A_FILTER_SELECT1		0x1A
#define AK4678_1B_FILTER_SELECT2		0x1B
#define AK4678_1C_SIDETONE_VOLUMEA		0x1C
#define AK4678_1D_LOUT_VOLUME			0x1D
#define AK4678_1E_ROUT_VOLUME			0x1E
#define AK4678_1F_PCM_IF_MANAGEMENT		0x1F
#define AK4678_20_PCM_IF_CONTROL0		0x20
#define AK4678_21_PCM_IF_CONTROL1		0x21
#define AK4678_22_SIDETONE_VOLUMEB		0x22
#define AK4678_23_DVOLB_CONTROL			0x23
#define AK4678_24_DVOLC_CONTROL			0x24
#define AK4678_25_DMIX_CONTROL0			0x25
#define AK4678_26_DMIX_CONTROL1		0x26
#define AK4678_27_DMIX_CONTROL2		0x27
#define AK4678_28_DMIX_CONTROL3		0x28

#define AK4678_29_FIL1_COEFFICIENT0	0x29
#define AK4678_2A_FIL1_COEFFICIENT1	0x2A
#define AK4678_2B_FIL1_COEFFICIENT2	0x2B
#define AK4678_2C_FIL1_COEFFICIENT3	0x2C
#define AK4678_2D_FIL2_COEFFICIENT0	0x2D
#define AK4678_2E_FIL2_COEFFICIENT1	0x2E
#define AK4678_2F_FIL2_COEFFICIENT2	0x2F
#define AK4678_30_FIL2_COEFFICIENT3	0x30
#define AK4678_31_FIL3_COEFFICIENT0	0x31
#define AK4678_32_FIL3_COEFFICIENT1	0x32
#define AK4678_33_FIL3_COEFFICIENT2	0x33
#define AK4678_34_FIL3_COEFFICIENT3	0x34
#define AK4678_35_EQ_COEFFICIENT0		0x35
#define AK4678_36_EQ_COEFFICIENT1		0x36
#define AK4678_37_EQ_COEFFICIENT2		0x37
#define AK4678_38_EQ_COEFFICIENT3		0x38
#define AK4678_39_EQ_COEFFICIENT4		0x39
#define AK4678_3A_EQ_COEFFICIENT5		0x3A
#define AK4678_3B_E1_COEFFICIENT0		0x3B
#define AK4678_3C_E1_COEFFICIENT1		0x3C
#define AK4678_3D_E1_COEFFICIENT2		0x3D
#define AK4678_3E_E1_COEFFICIENT3		0x3E
#define AK4678_3F_E1_COEFFICIENT4		0x3F
#define AK4678_40_E1_COEFFICIENT5		0x40
#define AK4678_41_E2_COEFFICIENT0		0x41
#define AK4678_42_E2_COEFFICIENT1		0x42
#define AK4678_43_E2_COEFFICIENT2		0x43
#define AK4678_44_E2_COEFFICIENT3		0x44
#define AK4678_45_E2_COEFFICIENT4		0x45
#define AK4678_46_E2_COEFFICIENT5		0x46
#define AK4678_47_E3_COEFFICIENT0		0x47
#define AK4678_48_E3_COEFFICIENT1		0x48
#define AK4678_49_E3_COEFFICIENT2		0x49
#define AK4678_4A_E3_COEFFICIENT3		0x4A
#define AK4678_4B_E3_COEFFICIENT4		0x4B
#define AK4678_4C_E3_COEFFICIENT5		0x4C

#define AK4678_50_5BAND_E1_COEF0      	0x50
#define AK4678_51_5BAND_E1_COEF1      	0x51
#define AK4678_52_5BAND_E1_COEF2      	0x52
#define AK4678_53_5BAND_E1_COEF3      	0x53
#define AK4678_54_5BAND_E2_COEF0      	0x54
#define AK4678_55_5BAND_E2_COEF1      	0x55
#define AK4678_56_5BAND_E2_COEF2      	0x56
#define AK4678_57_5BAND_E2_COEF3      	0x57
#define AK4678_58_5BAND_E2_COEF4      	0x58
#define AK4678_59_5BAND_E2_COEF5      	0x59
#define AK4678_5A_5BAND_E3_COEF0      	0x5A
#define AK4678_5B_5BAND_E3_COEF1      	0x5B
#define AK4678_5C_5BAND_E3_COEF2      	0x5C
#define AK4678_5D_5BAND_E3_COEF3      	0x5D
#define AK4678_5E_5BAND_E3_COEF4      	0x5E
#define AK4678_5F_5BAND_E3_COEF5      	0x5F
#define AK4678_60_5BAND_E4_COEF0      	0x60
#define AK4678_61_5BAND_E4_COEF1      	0x61
#define AK4678_62_5BAND_E4_COEF2      	0x62
#define AK4678_63_5BAND_E4_COEF3      	0x63
#define AK4678_64_5BAND_E4_COEF4      	0x64
#define AK4678_65_5BAND_E4_COEF5      	0x65
#define AK4678_66_5BAND_E5_COEF0      	0x66
#define AK4678_67_5BAND_E5_COEF1      	0x67
#define AK4678_68_5BAND_E5_COEF2      	0x68
#define AK4678_69_5BAND_E5_COEF3      	0x69
#define AK4678_6A_5BAND_E1_GAIN       	0x6A
#define AK4678_6B_5BAND_E2_GAIN       	0x6B
#define AK4678_6C_5BAND_E3_GAIN       	0x6C
#define AK4678_6D_5BAND_E4_GAIN       	0x6D
#define AK4678_6E_5BAND_E5_GAIN       	0x6E
#define AK4678_6FH_RESERVED        	0x6F

#define AK4678_70_DRC_MODE_CONTROL    	0x70
#define AK4678_71_NS_CONTROL         	0x71
#define AK4678_72_NS_GAIN_AND_ATT_CONTROL 	0x72
#define AK4678_73_NS_ON_LEVEL             	0x73
#define AK4678_74_NS_OFF_LEVEL            	0x74
#define AK4678_75_NS_REFERENCE_SELECT     	0x75
#define AK4678_76_NS_LPF_CO_EFFICIENT_0   	0x76
#define AK4678_77_NS_LPF_CO_EFFICIENT_1   	0x77
#define AK4678_78_NS_LPF_CO_EFFICIENT_2   	0x78
#define AK4678_79_NS_LPF_CO_EFFICIENT_3   	0x79
#define AK4678_7A_NS_HPF_CO_EFFICIENT_0   	0x7A
#define AK4678_7B_NS_HPF_CO_EFFICIENT_1   	0x7B
#define AK4678_7C_NS_HPF_CO_EFFICIENT_2   	0x7C
#define AK4678_7D_NS_HPF_CO_EFFICIENT_3   	0x7D
#define AK4678_7EH_RESERVED            	0x7E
#define AK4678_7FH_RESERVED            	0x7F
#define AK4678_80_DVLC_FILTER_SELECT      	0x80
#define AK4678_81_DVLC_MODE_CONTROL       	0x81
#define AK4678_82_DVLCL_CURVE_X1          	0x82
#define AK4678_83_DVLCL_CURVE_Y1          	0x83
#define AK4678_84_DVLCL_CURVE_X2         	0x84
#define AK4678_85_DVLCL_CURVE_Y2         	0x85
#define AK4678_86_DVLCL_CURVE_X3          	0x86
#define AK4678_87_DVLCL_CURVE_Y3         	0x87
#define AK4678_88_DVLCL_SLOPE_1           	0x88
#define AK4678_89_DVLCL_SLOPE_2          	0x89
#define AK4678_8A_DVLCL_SLOPE_3          	0x8A
#define AK4678_8B_DVLCL_SLOPE_4          	0x8B
#define AK4678_8C_DVLCM_CURVE_X1         	0x8C
#define AK4678_8D_DVLCM_CURVE_Y1          	0x8D
#define AK4678_8E_DVLCM_CURVE_X2         	0x8E
#define AK4678_8F_DVLCM_CURVE_Y2         	0x8F
#define AK4678_90_DVLCM_CURVE_X3        	0x90
#define AK4678_91_DVLCM_CURVE_Y3         	0x91
#define AK4678_92_DVLCM_SLOPE_1         	0x92
#define AK4678_93_DVLCM_SLOPE_2         	0x93
#define AK4678_94_DVLCM_SLOPE_3          	0x94
#define AK4678_95_DVLCM_SLOPE_4          	0x95
#define AK4678_96_DVLCH_CURVE_X1         	0x96
#define AK4678_97_DVLCH_CURVE_Y1          	0x97
#define AK4678_98_DVLCH_CURVE_X2          	0x98
#define AK4678_99_DVLCH_CURVE_Y2          	0x99
#define AK4678_9A_DVLCH_CURVE_X3          	0x9A
#define AK4678_9B_DVLCH_CURVE_Y3          	0x9B
#define AK4678_9C_DVLCH_SLOPE_1           	0x9C
#define AK4678_9D_DVLCH_SLOPE_2           	0x9D
#define AK4678_9E_DVLCH_SLOPE_3           	0x9E
#define AK4678_9F_DVLCH_SLOPE_4           	0x9F

#define AK4678_A0_DVLCL_LPF_CO_EFFICIENT_0		0xA0
#define AK4678_A1_DVLCL_LPF_CO_EFFICIENT_1		0xA1
#define AK4678_A2_DVLCL_LPF_CO_EFFICIENT_2     0xA2
#define AK4678_A3_DVLCL_LPF_CO_EFFICIENT_3     0xA3
#define AK4678_A4_DVLCM_HPF_CO_EFFICIENT_0     0xA4
#define AK4678_A5_DVLCM_HPF_CO_EFFICIENT_1     0xA5
#define AK4678_A6_DVLCM_HPF_CO_EFFICIENT_2     0xA6
#define AK4678_A7_DVLCM_HPF_CO_EFFICIENT_3     0xA7
#define AK4678_A8_DVLCM_LPF_CO_EFFICIENT_0     0xA8
#define AK4678_A9_DVLCM_LPF_CO_EFFICIENT_1     0xA9
#define AK4678_AA_DVLCM_LPF_CO_EFFICIENT_2     0xAA
#define AK4678_AB_DVLCM_LPF_CO_EFFICIENT_3     0xAB
#define AK4678_AC_DVLCH_HPF_CO_EFFICIENT_0     0xAC
#define AK4678_AD_DVLCH_HPF_CO_EFFICIENT_1     0xAD
#define AK4678_AE_DVLCH_HPF_CO_EFFICIENT_2     0xAE
#define AK4678_AF_DVLCH_HPF_CO_EFFICIENT_3     0xAF

#define AK4678_MAX_REGISTERS	(AK4678_AF_DVLCH_HPF_CO_EFFICIENT_3 + 1)

/* Bitfield Definitions */

/* AK4678_04_PLL_MODE_SELECT1 (0x04) Fields */
#define AK4678_PMPLL				0x01
#define AK4678_M_S					0x02
#define AK4678_BCKO					0x20

/* AK4678_05_FORMAT_SELECT (0x03) Fields */
#define AK4678_DIF					0x03
#define AK4678_DIF_DSP_MODE		(0 << 0)
#define AK4678_DIF_MSB_MODE		(2 << 0)
#define AK4678_DIF_I2S_MODE		(3 << 0)
#define AK4678_BCKP				0x04
#define AK4678_MSBS				0x08
#define AK4678_SDOD				0x10

/* AK4678_AD_DA_POWER_MANAGEMENT (0x00) Fields */
#define AK4678_PMVCM				0x01

/* 00H AKMC_POWER_MANAGEMENT_0           */
#define AK4678_POWER_MANAGEMENT_0_PMVCM       0x01
#define AK4678_POWER_MANAGEMENT_0_PMPFIL      0x02
#define AK4678_POWER_MANAGEMENT_0_PMADL       0x10
#define AK4678_POWER_MANAGEMENT_0_PMADR       0x20

/* 01H AKMC_POWER_MANAGEMENT_1           */
#define AK4678_POWER_MANAGEMENT_1_PMEQ        0x01
#define AK4678_POWER_MANAGEMENT_1_PMDRC       0x02
#define AK4678_POWER_MANAGEMENT_1_PMDAL       0x04
#define AK4678_POWER_MANAGEMENT_1_PMDAR       0x08

/* 02H AKMC_POWER_MANAGEMENT_2           */
#define AK4678_POWER_MANAGEMENT_2_PMMP1       0x01
#define AK4678_POWER_MANAGEMENT_2_MICL1       0x02
#define AK4678_POWER_MANAGEMENT_2_PMMP2       0x04
#define AK4678_POWER_MANAGEMENT_2_MICL2       0x08
#define AK4678_POWER_MANAGEMENT_2_ADRST       0x80

/* 03H AKMC_PLL_MODE_SELECT_0            */
#define AK4678_PLL_MODE_SELECT_0_PLL0         0x01
#define AK4678_PLL_MODE_SELECT_0_PLL1         0x02
#define AK4678_PLL_MODE_SELECT_0_PLL2         0x04
#define AK4678_PLL_MODE_SELECT_0_PLL3         0x08
#define AK4678_PLL_MODE_SELECT_0_FS0          0x10
#define AK4678_PLL_MODE_SELECT_0_FS1          0x20
#define AK4678_PLL_MODE_SELECT_0_FS2          0x40
#define AK4678_PLL_MODE_SELECT_0_FS3          0x80

/* AK4678_03_PLL_MODE_SELECT0 (0x03) Fields */


#define AK4678_PLL					0x0f
#define AK4678_EXT_SLAVE			 0
#define AK4678_EXT_MASTER			 1
#define AK4678_PLL_SLAVE             2
#define AK4678_PLL_MASTER            3
#define AK4678_BICKO_32FS            4
#define AK4678_BICKO_64FS            5




#define AK4678_PLL_BICK32			(2 << 0)
#define AK4678_PLL_BICK64			(3 << 0)
#define AK4678_PLL_11_2896MHZ		(4 << 0)
#define AK4678_PLL_12_288MHZ		(5 << 0)
#define AK4678_PLL_12MHZ			(6 << 0)
#define AK4678_PLL_24MHZ			(7 << 0)
#define AK4678_PLL_19_2MHZ			(8 << 0)
#define AK4678_PLL_13_5MHZ			(12 << 0)
#define AK4678_PLL_27MHZ			(13 << 0)
#define AK4678_PLL_13MHZ			(14 << 0)
#define AK4678_PLL_26MHZ			(15 << 0)
#define AK4678_FS					0xf0
#define AK4678_FS_8KHZ				(0 << 4)
#define AK4678_FS_12KHZ			(1 << 4)
#define AK4678_FS_16KHZ			(2 << 4)
#define AK4678_FS_24KHZ			(3 << 4)
#define AK4678_FS_11_025KHZ		(5 << 4)
#define AK4678_FS_22_05KHZ			(7 << 4)
#define AK4678_FS_32KHZ			(10 << 4)
#define AK4678_FS_48KHZ			(11 << 4)
#define AK4678_FS_44_1KHZ			(15 << 4)

/* 04H AKMC_PLL_MODE_SELECT_1            */
#define AK4678_PLL_MODE_SELECT_1_PMPLL        0x01
#define AK4678_PLL_MODE_SELECT_1_MS           0x02
#define AK4678_PLL_MODE_SELECT_1_BCKO         0x20
#define AK4678_PLL_MODE_SELECT_1_CM           0xC0
#define AK4678_PLL_MODE_SELECT_1_CM0          0x0
#define AK4678_PLL_MODE_SELECT_1_CM1          0x40
#define AK4678_PLL_MODE_SELECT_1_CM2          0x80


/* 05H AKMC_AUDIO_IF_FORMAT_SELECT       */
#define AK4678_AUDIO_IF_FORMAT_SELECT_DIF0    0x01
#define AK4678_AUDIO_IF_FORMAT_SELECT_DIF1    0x02
#define AK4678_AUDIO_IF_FORMAT_SELECT_BCKP    0x04
#define AK4678_AUDIO_IF_FORMAT_SELECT_MSBS    0x08
#define AK4678_AUDIO_IF_FORMAT_SELECT_SDOD    0x10

/* 15H AK4678_15_ALCTIMER_SELECT WTM  */
#define AK4678_WTM		0x1C
#define AK4678_WTM_FS11	0x08
#define AK4678_WTM_FS22	0x0C
#define AK4678_WTM_FS44	0x10

/**
 * struct ak4678_platform_data - platform specific AK4678 configuration
 * @gpio_power:	GPIO to control external power to AK4678
 * @gpio_npdn:	GPIO connected to AK4678 nPDN pin
 *
 * Both GPIO parameters are optional.
 */
struct ak4678_platform_data {
	//int gpio_power;
	int gpio_pdn;
};



/* AK4678 Sequence setting */
#define AK4679_DSP_COMMAND    0x201

typedef struct {
	u16	nAddr;	// Register Address at nAddr < 0x100
	u16	nMask;	//  wait time(ms) at nAddr = AK4678_M_DELAY
	u16	nData;	// 
} AKSEQUENCE;


typedef struct {
	AKSEQUENCE *akseq;
	u16        size;
} AKSEQ_SIZE;

static AKSEQUENCE akseq_stereoef_on[] = {
	{AK4678_1A_FILTER_SELECT1, 0xC, 0xC},
};

static AKSEQUENCE akseq_stereoef_off[] = {
	{AK4678_1A_FILTER_SELECT1, 0xC, 0x0},
};

static AKSEQUENCE akseq_dvlc_drc_on[] = {
	{AK4678_70_DRC_MODE_CONTROL, 0x3, 0x3},
	{AK4678_71_NS_CONTROL, 0x6, 0x6},
	{AK4678_80_DVLC_FILTER_SELECT, 0x55, 0x55}
};

static AKSEQUENCE akseq_dvlc_drc_off[] = {
	{AK4678_70_DRC_MODE_CONTROL, 0x3, 0x0},
	{AK4678_71_NS_CONTROL, 0xff, 0x0},
	{AK4678_80_DVLC_FILTER_SELECT, 0xff, 0x0}    
};

#endif
